/* You may modify this file as desired.
   UCI contact:

   Steve Pier
   Univeristy of California, Irvine
   pier@nucleus.ps.uci.edu
   714-824-3162

*/


/* hostspec.h
   This file contains host-specific definitions for DSP initialization and
   communication.  The user may change this file to accommodate any specific
   VME host processor.
*/

typedef long int32;                  /* int32 is a signed 32-bit integer */
typedef unsigned long u_int32;		/* uint32 is an unsigned 32-bit integer */


#if 0		/* standard systems */
#include <stdio.h>		
#endif

#if 1		/* VxWorks */
#include <stdio.h>			/* for file functions and printf() */
#endif


/********************** time-related definitions ***********************/
/*       choose one of the following #if blocks or add your own        */

		/* if standard C library time functions are available */
#include <time.h>
	/* function that returns clock ticks since t == t0 */
#define CLOCK() clock()   
	/* number of clock ticks before timeout, set to ~2 seconds */
#define TIMEOUT_PERIOD  (2*CLOCKS_PER_SEC)
	/* number of clock ticks to wait while DSP's reset, set to > 750 ms */
#define DSP_RES_PERIOD  (CLOCKS_PER_SEC)



/***************** end of time-related definitions *********************/




	/* Error logging functions:
	   log_err() and log_boot() use printf() to print out error messages.
	   Other functions may be subsituted for log_err() and log_boot().
	   To access some global variables, functions may be included in
	   hos_init.c */

	/* max number of errors to log; subsequent errors are counted but not logged */
#define MAX_ERR_LOG  (50)

	/* parm1 = int error code, 	parm2 = char* error message */
	/* note that a host-specific offset may be added to parm1 here */
#define LOG_ERR(parm1, parm2) log_err((1000+parm1), parm2)	/* log error */

	/* parm1 = dsp_no */
#define LOG_BOOT(parm1) log_boot(parm1)				/* log contents of boot structure */
