
#define I_AM_HOST

#include "hostspec.h"
#include "sys_pub.h"
#include "sys_priv.h"
#include "sys_gen.h"



/* Still to be done:   Fix abort code on vme side.  */
/*                     Get a better user interface for message composing  */
/*                     Test flag stuff       */
/*                     Fix big_mess stuff    */



/* ================================================================= */
/*   faster way to use look ().   from Sandra's code                 */
/* ================================================================= */


extern dpr *io_base[];

static int hackvar;

#define look(dsp, sig) ((io_base[dsp]->signals == (hackvar = io_base[dsp]->signals)) \
		? (hackvar >> sig) & 1 \
		: ((io_base[dsp]->signals >> sig) & 1))


/* ====================================================================== */


int sys_set(int dest, int signal)		/* sets a bit in signal word */
{	
      
	extern dpr *io_base[];
	int x = 1;

	if ((signal < 0) || (signal > NUM_FLAGS))
		return(ENOSIG);
     
	io_base[dest]->signals |= (x << signal); 
    return ( SUCCESS );

}


/* ====================================================================== */


int sys_clear(int dest, int signal)
{

	extern dpr *io_base[];  
	int    x = 1;
  
	if((signal < 0) || (signal > NUM_FLAGS))
		return(ENOSIG);
      
	io_base[dest]->signals &= ~(x << signal); 
    return(SUCCESS);

}


/* ====================================================================== */


int sys_wait(int dest, int signal)
{
  
	while (!(look(dest, signal))) {
		if(look(dest, ABORT))
			return(EABORT);

		/* loop_delay (); */
	}
	     
	return ( SUCCESS );

}


/* ====================================================================== */


int
sys_nwait(int dest, int signal)
{

	while ( look (dest, signal) ) {
		if(look(dest, ABORT))
			return(EABORT);

		/* loop_delay (); */
	}
           
	return ( SUCCESS );

}


/* ====================================================================== */


/*
int
look(int dest, int sig)
{    

	int32 a[LOOKUPS];
    int   n;
    extern dpr *io_base[];

    for(n = 0;n < LOOKUPS; n++) {
		a[n] = (io_base[dest]->signals) & (1 << sig);
	    if(n != 0) {
			if(a[n] != a[n-1])
				return ECONFLICT;
	    }
      
	}
      
	if(a[0]) return(1);
      
	return(0);

}
*/


/* ====================================================================== */

int get_sigs( int dest )
{
   
	return io_base[dest]->signals;

}


/* ====================================================================== */

int  send_mess( int32 *pmess )
{

	int         remain;
	int         dest;
	int32       *from, *to;
	static int  mess_id = 0;


	m_generic   *message;
	

	message = (m_generic *) pmess;
   dest    = MDEST(message);
   remain  = MSIZE(message);
   
	
   if(look(dest, EXPORT))
		return ECONFLICT;
	
   sys_set(dest, IMPORT);
	
  	if(look(dest, EXPORT))
		return ECONFLICT;
	

	mess_id++;
	
	io_base[dest]->packet.header.id         = mess_id; 
	io_base[dest]->packet.header.timestamp  = 0; 
	io_base[dest]->packet.header.return_add = 0; 
	io_base[dest]->packet.header.size       = remain;

	
	from = (int32 *) message;
	to   = io_base[dest]->packet.message;


	/* ---------------------------------- */
	/*     copy data from local to dsp    */
	/* ---------------------------------- */


	while ( remain > MTU )  {
	
		copy (from, to, MTU);
		remain -= MTU;
		from   += MTU;
		
		sys_set (dest, DAV);
		if ( sys_wait (dest, ACK) == EABORT )
			return EABORT;
		sys_clear (dest, DAV);
		if ( sys_nwait (dest, ACK) == EABORT )
			return EABORT;
	}


	copy (from, to, remain);
	to += remain;
	zero (to, (MTU - remain));


	/* --------------------- */
	/*   end send message    */
	/* --------------------- */


	sys_set   (dest, EOM);	
	sys_set   (dest, DAV);
	sys_wait  (dest, ACK);  	
	sys_clear (dest, EOM);
	sys_clear (dest, IMPORT);	
	sys_clear (dest, DAV);	
	
	if ( sys_nwait (dest, ACK) != SUCCESS ) {
		printf ("  sys_nwait no succes in send mess \n");
	}
		

	return (SUCCESS);

}


/* ====================================================================== */


int get_mess ( int dest )
{

      
	int32  *to, *from;
	int32  remain;

	//int32  maxtsize = 0x2000;   /*  FIXME  was 10000 t.d. */
	int32  maxtsize = 0x10000; 


	extern int32  *message_base;
 

	// printf (" get_mess  %lx  %lx\n", message_base, io_base[0]);


    from = io_base[dest]->packet.message;
    to   = message_base;

    if ( !look (dest, EXPORT ) )
		return ENOMESS;

    if ( sys_wait (dest, DAV ) == EABORT )
		return EABORT; 

	 
    if ( (remain = io_base[dest]->packet.header.size ) > maxtsize )
		return ETOOBIG;


    while ( remain > MTU ) {

		 copy( from, to, MTU );
		 to += MTU; 
		 remain -= MTU;

		 sys_set( dest, ACK );
		 if ( sys_nwait( dest, DAV ) == EABORT)
			 return EABORT;

		 sys_clear( dest, ACK );
		 if ( sys_wait( dest, DAV ) == EABORT )
			 return EABORT;      
	 }

    copy( from, to, remain );
    sys_set( dest, ACK );
    if ( sys_nwait( dest, DAV ) == EABORT )
		 return EABORT;
    
	 sys_clear( dest, ACK );
	 
    return SUCCESS;

}


/* ====================================================================== */


void  copy( int32 *from, int32 *to, int32 n )
{

	int32 c;
	
	if((!from) || (!to))
		return;
	
	if(n == 0)	
		return;
	
	for ( c = n; c != 0; c-- ) 
		*to++ = *from++;
	
}

/* ====================================================================== */


void zero( int32 *to, int32 n)
{
	
	int32 c;
	
	if((!to) || !(n > 0))
		return;
	
	for( c = n; c != 0; c--)
		*to++ = 0;
	
}


/* ====================================================================== */


int get_flag( int dest, int flag )
{

	
	int val;
	
	
	if ( (dest > (NUM_CHAN - 1)) || (flag > (NUM_FLAGS - 1)) )
		return ENOSIG;
	
	val = FLAG( dest, flag);
	
	
	/* printf ("  flag  %d   %d\n", flag, val); */
	
	return val;

}


/* ====================================================================== */
/* ====================================================================== */

void print_flag ()
{

	/*
	printf ("  boot code version  %d\n",  io_base[0]->flags[BOOT_CODE_VERSION]);
	printf ("  code version       %d\n",  io_base[0]->flags[CODEVER_SYS]);
	printf ("  user code version  %d\n",  io_base[0]->flags[CODEVER_SCOM_US]);
	*/
	printf ("  dsp state          %d\n",  io_base[0]->flags[DSP_STATE]);
	printf ("  host state         %d\n",  io_base[0]->flags[HOST_STATE]);
	printf ("  verbose flag       %d\n",  io_base[0]->flags[VERBOSE_FLAG]);


}


/* ====================================================================== */

int  set_flag( int dest, int flag, int val )
{
	
	if ( (dest > (NUM_CHAN - 1)) || (flag > (NUM_FLAGS - 1)) )
		return ENOSIG;
	
	FLAG( dest, flag) = val;

}


/* ====================================================================== */


int message_status( void )
{
	
	int stat = 0;
	int n;
	
	for ( n = NUM_CHAN - 1; n >= 0; n-- )  {
		if( __check_mess(n) == 0 )  {
			stat <<= 1;
			continue;
		}
		stat <<= 1;
		stat += 1;
      
	}
	
	return stat;

}     


/* ====================================================================== */


int __check_mess(int dest)
{
	
	if ( io_base[dest]->signals & (1 << EXPORT) )
		return 1;
	
	return 0;

}


/* ====================================================================== */


int check_mess(int dest)
{
	
	int val;
	
	val = __check_mess( dest );
	
	return val;

}


/* ====================================================================== */


int m_wait(int dest)
{
 
	
	int n; 
	
   
	while ( !(n = look(0, EXPORT)) ) {
		if ( n == ECONFLICT )
			return ECONFLICT;
	}
	
	return SUCCESS;

}


/* ====================================================================== */


int32*  dsp_base( int dsp )
{

	return (int32 *) io_base[dsp];

}


/* ====================================================================== */


void 
dsp_led( int dsp_no, int on )  /* turns red LED on DSP's VME card on or off */
{
      int i;

      i = get_port( dsp_no );	/* get theoretical current value in port */

      i &= ~0x80;		/* clear bit 7 = turn LED on */
      if ( ! on )  i |= 0x80;	/* set   bit 7 = turn LED off */

      set_port( dsp_no, i );	/* write new value to port */
}


/* ====================================================================== */


void 
interrupt_dsp( int dsp_no )    /* interrupts DSP */
{
      int i;

      i = get_port( dsp_no );	/* get theoretical current value in port */

      i |= 0x2;			/* set   bit 1 */
      set_port( dsp_no, i );
      i &= ~0x2;		/* clear bit 1 */
      set_port( dsp_no, i );
      i |= 0x2;			/* set   bit 1 */
      set_port( dsp_no, i );
}


/* ====================================================================== */
/*                                                                        */
/* ====================================================================== */

int port_image[ NUM_CHAN ];  /* image of VME cards' host ports */


/* ====================================================================== */


int 
get_port( int dsp_no )      /* returns image of port */
{
      return( port_image[ dsp_no ] ); /* return image of port */
}


/* ====================================================================== */


void 
set_port( int dsp_no, int value )  /* writes value to port */
{

      
	* ( dsp_base( dsp_no ) + PORT_OFFSET ) = value; /* write to hardware */  
	port_image[ dsp_no ]            = value; /* write to image */

	/*
	printf (" port  %x  %x\n", dsp_base( dsp_no ), dsp_base( dsp_no ) + PORT_OFFSET);
	*/
}



/* ============================================================== */
/*       abort functions from Sandra's code                       */
/* ============================================================== */


int com_abort (int dest)
{

	sys_set (dest, ABORT);
	sys_wait (dest, ACK);
	sys_clear (dest, ABORT);
	sys_nwait (dest, ACK);

	return ( SUCCESS );

}


void com_aborted (int dest)
{

	/*
	sys_set (dest, ABORT);
	sys_wait (dest, ACK);
	sys_clear (dest, ABORT);
	sys_nwait (dest, ACK);

	return ( SUCCESS );
	*/

	return; 
}


int loop_delay ()
{
	
	int  a = 0;
	int  i;


	for ( i = 0; i < 10000000; i++ ) {
		if ( i % 2 == 1 )
			a++;
	}
	
	return a;
	
}
